(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('rxjs/operators'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('@ng-web-apis/audio', ['exports', 'rxjs', 'rxjs/operators', '@angular/core'], factory) :
    (factory((global['ng-web-apis'] = global['ng-web-apis'] || {}, global['ng-web-apis'].audio = {}),global.rxjs,global.rxjs.operators,global.ng.core));
}(this, (function (exports,rxjs,operators,i0) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} param
     * @param {?} value
     * @param {?=} currentTime
     * @return {?}
     */
    function processAudioParam(param, value, currentTime) {
        if (currentTime === void 0) {
            currentTime = 0;
        }
        if (param.cancelAndHoldAtTime) {
            param.cancelAndHoldAtTime(currentTime);
        }
        else {
            param.cancelScheduledValues(currentTime);
            param.setValueAtTime(param.value, currentTime);
        }
        if (typeof value === 'number') {
            param.value = value;
            return;
        }
        if (value instanceof Array) {
            processSchedule(param, value, currentTime);
            return;
        }
        if (!('mode' in value)) {
            param.setValueCurveAtTime(value.value, currentTime, value.duration);
            return;
        }
        param.setValueAtTime(param.value, currentTime);
        processAutomation(param, value, currentTime);
    }
    /**
     * @param {?} param
     * @param {?} value
     * @param {?} currentTime
     * @return {?}
     */
    function processSchedule(param, value, currentTime) {
        value.forEach(function (automation) {
            if ('mode' in automation) {
                processAutomation(param, automation, currentTime);
            }
            else {
                param.setValueCurveAtTime(automation.value, currentTime, automation.duration);
            }
        });
    }
    /**
     * @param {?} param
     * @param {?} __1
     * @param {?} currentTime
     * @return {?}
     */
    function processAutomation(param, _a, currentTime) {
        var value = _a.value, _b = _a.mode, mode = _b === void 0 ? 'instant' : _b, duration = _a.duration;
        switch (mode) {
            case 'instant':
                param.setValueAtTime(value, currentTime);
                param.setValueAtTime(value, currentTime + duration);
                break;
            case 'exponential':
                param.exponentialRampToValueAtTime(value || 0.001, currentTime + duration);
                param.setValueAtTime(value, currentTime + duration);
                break;
            case 'linear':
                param.linearRampToValueAtTime(value, currentTime + duration);
                break;
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template K
     * @param {?=} param
     * @return {?}
     */
    function audioParam(param) {
        if (param === void 0) {
            param = '';
        }
        /** @type {?} */
        var decorator = function (target, propertyKey) {
            Object.defineProperty(target, propertyKey, {
                set: /**
                 * @this {?}
                 * @param {?} value
                 * @return {?}
                 */ function (value) {
                    /** @type {?} */
                    var audioParam = this instanceof AudioWorkletNode
                        ? (( /** @type {?} */(this.parameters))).get(propertyKey)
                        : this[( /** @type {?} */(param))];
                    if (audioParam instanceof AudioParam) {
                        processAudioParam(audioParam, value, this.context.currentTime);
                    }
                    else {
                        // Fallback for older browsers
                        Object.defineProperty(target, propertyKey, { value: value });
                    }
                },
            });
        };
        return decorator;
    }

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var AUDIO_CONTEXT = new i0.InjectionToken('Web Audio API context', {
        providedIn: 'root',
        factory: function () { return new AudioContext(); },
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} latencyHint
     * @return {?}
     */
    function latencyHintFactory(latencyHint) {
        return latencyHint === null
            ? undefined
            : Number.parseFloat(latencyHint) || latencyHint;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioContext = /** @class */ (function (_super) {
        __extends(WebAudioContext, _super);
        function WebAudioContext(latencyHint, sampleRate) {
            return _super.call(this, {
                latencyHint: latencyHintFactory(latencyHint),
                sampleRate: Number.parseInt(sampleRate || '', 10) || undefined,
            }) || this;
        }
        /**
         * @return {?}
         */
        WebAudioContext.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.close();
            };
        WebAudioContext.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waAudioContext]',
                        providers: [
                            {
                                provide: AUDIO_CONTEXT,
                                useExisting: i0.forwardRef(function () { return WebAudioContext; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioContext.ctorParameters = function () {
            return [
                { type: undefined, decorators: [{ type: i0.Attribute, args: ['latencyHint',] }] },
                { type: undefined, decorators: [{ type: i0.Attribute, args: ['sampleRate',] }] }
            ];
        };
        return WebAudioContext;
    }(AudioContext));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     * @param {?} context
     * @param {?} method
     * @param {?} constructor
     * @param {?=} node
     * @param {...?} args
     * @return {?}
     */
    function constructorPolyfill(context, method, constructor, node) {
        if (node === void 0) {
            node = null;
        }
        var args = [];
        for (var _i = 4; _i < arguments.length; _i++) {
            args[_i - 4] = arguments[_i];
        }
        try {
            // @ts-ignore
            /** @type {?} */
            var _test = new GainNode(context);
        }
        catch (_) {
            /** @type {?} */
            var result = ( /** @type {?} */(context[method]()));
            Object.setPrototypeOf(result, constructor.prototype);
            constructor.init.apply(constructor, __spread([result, node], args));
            return result;
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioChannel = /** @class */ (function (_super) {
        __extends(WebAudioChannel, _super);
        function WebAudioChannel(context) {
            var _this = this;
            /** @type {?} */
            var result = constructorPolyfill(context, 'createGain', WebAudioChannel);
            if (result) {
                return result;
            }
            _this = _super.call(this, context) || this;
            return _this;
        }
        /**
         * @return {?}
         */
        WebAudioChannel.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        /**
         * @return {?}
         */
        WebAudioChannel.init = /**
         * @return {?}
         */
            function () { };
        WebAudioChannel.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waChannel]',
                        exportAs: 'AudioNode',
                    },] }
        ];
        /** @nocollapse */
        WebAudioChannel.ctorParameters = function () {
            return [
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] }
            ];
        };
        return WebAudioChannel;
    }(GainNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DC_OFFSET = 128;

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var POLLING_TIME = 100;

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var AUDIO_NODE = new i0.InjectionToken('Web Audio API audio node', {
        factory: function () { return null; },
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?=} source
     * @param {?=} destination
     * @return {?}
     */
    function connect(source, destination) {
        if (source && destination) {
            // @ts-ignore TS does not have a union override for connect method
            source.connect(destination);
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioDestination = /** @class */ (function (_super) {
        __extends(WebAudioDestination, _super);
        function WebAudioDestination(context, node) {
            var _this = this;
            /** @type {?} */
            var result = constructorPolyfill(context, 'createAnalyser', WebAudioDestination, node);
            if (result) {
                return result;
            }
            _this = _super.call(this, context) || this;
            WebAudioDestination.init(_this, node);
            return _this;
        }
        /**
         * @return {?}
         */
        WebAudioDestination.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        /**
         * @private
         * @param {?} array
         * @return {?}
         */
        WebAudioDestination.prototype.isSilent = /**
         * @private
         * @param {?} array
         * @return {?}
         */
            function (array) {
                for (var i = 0; i < array.length; i++) {
                    if (Math.abs(array[i] - DC_OFFSET) > 2) {
                        return false;
                    }
                }
                return true;
            };
        /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
        WebAudioDestination.init = /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
            function (that, node) {
                connect(node, that);
                that.fftSize = 256;
                that.connect(that.context.destination);
                that.quiet = rxjs.interval(POLLING_TIME).pipe(operators.mapTo(new Uint8Array(that.fftSize)), operators.tap(function (array) { return that.getByteTimeDomainData(array); }), operators.map(function (array) { return that.isSilent(array); }), operators.distinctUntilChanged(), operators.debounceTime(1000), operators.filter(function (isSilent) { return isSilent; }), operators.skip(1));
            };
        WebAudioDestination.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waAudioDestinationNode]',
                        exportAs: 'AudioNode',
                    },] }
        ];
        /** @nocollapse */
        WebAudioDestination.ctorParameters = function () {
            return [
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.Inject, args: [AUDIO_NODE,] }] }
            ];
        };
        WebAudioDestination.propDecorators = {
            quiet: [{ type: i0.Output }]
        };
        return WebAudioDestination;
    }(AnalyserNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?=} value
     * @return {?}
     */
    function fallbackAudioParam(value) {
        if (!value) {
            return 0;
        }
        if (typeof value === 'number') {
            return value;
        }
        if (value instanceof Array) {
            /** @type {?} */
            var last = value[value.length - 1].value;
            return typeof last === 'number' ? last : last[last.length - 1];
        }
        if (value.value instanceof Array) {
            return value.value[value.value.length - 1];
        }
        return value.value;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioListener = /** @class */ (function (_super) {
        __extends(WebAudioListener, _super);
        function WebAudioListener(context) {
            var _this = this;
            /** @type {?} */
            var result = constructorPolyfill(context, 'createGain', WebAudioListener);
            if (result) {
                return result;
            }
            _this = _super.call(this, context) || this;
            return _this;
        }
        Object.defineProperty(WebAudioListener.prototype, "forwardX", {
            get: /**
             * @return {?}
             */ function () {
                return this.context.listener.forwardX;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WebAudioListener.prototype, "forwardY", {
            get: /**
             * @return {?}
             */ function () {
                return this.context.listener.forwardY;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WebAudioListener.prototype, "forwardZ", {
            get: /**
             * @return {?}
             */ function () {
                return this.context.listener.forwardZ;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WebAudioListener.prototype, "positionX", {
            get: /**
             * @return {?}
             */ function () {
                return this.context.listener.positionX;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WebAudioListener.prototype, "positionY", {
            get: /**
             * @return {?}
             */ function () {
                return this.context.listener.positionY;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WebAudioListener.prototype, "positionZ", {
            get: /**
             * @return {?}
             */ function () {
                return this.context.listener.positionZ;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WebAudioListener.prototype, "upX", {
            get: /**
             * @return {?}
             */ function () {
                return this.context.listener.upX;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WebAudioListener.prototype, "upY", {
            get: /**
             * @return {?}
             */ function () {
                return this.context.listener.upY;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WebAudioListener.prototype, "upZ", {
            get: /**
             * @return {?}
             */ function () {
                return this.context.listener.upZ;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        WebAudioListener.prototype.ngOnChanges = /**
         * @return {?}
         */
            function () {
                if (this.context.listener.positionX instanceof AudioParam) {
                    return;
                }
                // Fallback for older browsers
                this.context.listener.setOrientation(fallbackAudioParam(this.forwardXParam), fallbackAudioParam(this.forwardYParam), fallbackAudioParam(this.forwardZParam), fallbackAudioParam(this.upXParam), fallbackAudioParam(this.upYParam), fallbackAudioParam(this.upZParam));
                this.context.listener.setPosition(fallbackAudioParam(this.positionXParam), fallbackAudioParam(this.positionYParam), fallbackAudioParam(this.positionZParam));
            };
        /**
         * @return {?}
         */
        WebAudioListener.init = /**
         * @return {?}
         */
            function () { };
        WebAudioListener.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waAudioContext],[waOfflineAudioContext][length][sampleRate]',
                    },] }
        ];
        /** @nocollapse */
        WebAudioListener.ctorParameters = function () {
            return [
                { type: BaseAudioContext, decorators: [{ type: i0.Self }, { type: i0.Inject, args: [AUDIO_CONTEXT,] }] }
            ];
        };
        WebAudioListener.propDecorators = {
            forwardXParam: [{ type: i0.Input, args: ['forwardX',] }],
            forwardYParam: [{ type: i0.Input, args: ['forwardY',] }],
            forwardZParam: [{ type: i0.Input, args: ['forwardZ',] }],
            positionXParam: [{ type: i0.Input, args: ['positionX',] }],
            positionYParam: [{ type: i0.Input, args: ['positionY',] }],
            positionZParam: [{ type: i0.Input, args: ['positionZ',] }],
            upXParam: [{ type: i0.Input, args: ['upX',] }],
            upYParam: [{ type: i0.Input, args: ['upY',] }],
            upZParam: [{ type: i0.Input, args: ['upZ',] }]
        };
        __decorate([
            audioParam('forwardX'),
            __metadata("design:type", Object)
        ], WebAudioListener.prototype, "forwardXParam", void 0);
        __decorate([
            audioParam('forwardY'),
            __metadata("design:type", Object)
        ], WebAudioListener.prototype, "forwardYParam", void 0);
        __decorate([
            audioParam('forwardZ'),
            __metadata("design:type", Object)
        ], WebAudioListener.prototype, "forwardZParam", void 0);
        __decorate([
            audioParam('positionX'),
            __metadata("design:type", Object)
        ], WebAudioListener.prototype, "positionXParam", void 0);
        __decorate([
            audioParam('positionY'),
            __metadata("design:type", Object)
        ], WebAudioListener.prototype, "positionYParam", void 0);
        __decorate([
            audioParam('positionZ'),
            __metadata("design:type", Object)
        ], WebAudioListener.prototype, "positionZParam", void 0);
        __decorate([
            audioParam('upX'),
            __metadata("design:type", Object)
        ], WebAudioListener.prototype, "upXParam", void 0);
        __decorate([
            audioParam('upY'),
            __metadata("design:type", Object)
        ], WebAudioListener.prototype, "upYParam", void 0);
        __decorate([
            audioParam('upZ'),
            __metadata("design:type", Object)
        ], WebAudioListener.prototype, "upZParam", void 0);
        return WebAudioListener;
    }(GainNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioOfflineContext = /** @class */ (function (_super) {
        __extends(WebAudioOfflineContext, _super);
        function WebAudioOfflineContext(length, sampleRate, numberOfChannels, autoplay) {
            var _this = _super.call(this, Number.parseInt(numberOfChannels || '', 10) || 1, Number.parseInt(length, 10), Number.parseInt(sampleRate, 10)) || this;
            _this.complete = new i0.EventEmitter();
            _this.oncomplete = function (_a) {
                var renderedBuffer = _a.renderedBuffer;
                return _this.complete.emit(renderedBuffer);
            };
            if (autoplay !== null) {
                _this.startRendering();
            }
            return _this;
        }
        WebAudioOfflineContext.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waOfflineAudioContext][length][sampleRate]',
                        providers: [
                            {
                                provide: AUDIO_CONTEXT,
                                useExisting: i0.forwardRef(function () { return WebAudioOfflineContext; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioOfflineContext.ctorParameters = function () {
            return [
                { type: String, decorators: [{ type: i0.Attribute, args: ['length',] }] },
                { type: String, decorators: [{ type: i0.Attribute, args: ['sampleRate',] }] },
                { type: undefined, decorators: [{ type: i0.Attribute, args: ['numberOfChannels',] }] },
                { type: undefined, decorators: [{ type: i0.Attribute, args: ['autoplay',] }] }
            ];
        };
        WebAudioOfflineContext.propDecorators = {
            complete: [{ type: i0.Output }]
        };
        return WebAudioOfflineContext;
    }(OfflineAudioContext));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioOutput = /** @class */ (function (_super) {
        __extends(WebAudioOutput, _super);
        function WebAudioOutput(context, node) {
            var _this = this;
            /** @type {?} */
            var result = constructorPolyfill(context, 'createGain', WebAudioOutput, node);
            if (result) {
                return result;
            }
            _this = _super.call(this, context) || this;
            WebAudioOutput.init(_this, node);
            return _this;
        }
        Object.defineProperty(WebAudioOutput.prototype, "waOutput", {
            set: /**
             * @param {?} destination
             * @return {?}
             */ function (destination) {
                this.disconnect();
                connect(this, destination);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        WebAudioOutput.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
        WebAudioOutput.init = /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
            function (that, node) {
                connect(node, that);
            };
        WebAudioOutput.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waOutput]',
                    },] }
        ];
        /** @nocollapse */
        WebAudioOutput.ctorParameters = function () {
            return [
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.Inject, args: [AUDIO_NODE,] }] }
            ];
        };
        WebAudioOutput.propDecorators = {
            waOutput: [{ type: i0.Input }]
        };
        return WebAudioOutput;
    }(GainNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioMediaStreamDestination = /** @class */ (function (_super) {
        __extends(WebAudioMediaStreamDestination, _super);
        function WebAudioMediaStreamDestination(context, node) {
            var _this = this;
            try {
                // @ts-ignore
                /** @type {?} */
                var _test = new GainNode(context);
            }
            catch (_) {
                /** @type {?} */
                var result = context.createMediaStreamDestination();
                Object.setPrototypeOf(result, WebAudioMediaStreamDestination.prototype);
                connect(node, result);
                return ( /** @type {?} */(result));
            }
            _this = _super.call(this, context) || this;
            connect(node, _this);
            return _this;
        }
        WebAudioMediaStreamDestination.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waMediaStreamAudioDestinationNode]',
                        exportAs: 'AudioNode',
                    },] }
        ];
        /** @nocollapse */
        WebAudioMediaStreamDestination.ctorParameters = function () {
            return [
                { type: AudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.Inject, args: [AUDIO_NODE,] }] }
            ];
        };
        return WebAudioMediaStreamDestination;
    }(MediaStreamAudioDestinationNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioAnalyser = /** @class */ (function (_super) {
        __extends(WebAudioAnalyser, _super);
        function WebAudioAnalyser(context, node) {
            var _this = this;
            /** @type {?} */
            var result = constructorPolyfill(context, 'createAnalyser', WebAudioAnalyser, node);
            if (result) {
                return result;
            }
            _this = _super.call(this, context) || this;
            WebAudioAnalyser.init(_this, node);
            return _this;
        }
        /**
         * @return {?}
         */
        WebAudioAnalyser.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
        WebAudioAnalyser.init = /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
            function (that, node) {
                connect(node, that);
                that.frequencyByte$ = rxjs.interval(0, rxjs.animationFrameScheduler).pipe(operators.mapTo(new Uint8Array(that.frequencyBinCount)), operators.map(function (array) {
                    return array.length === that.frequencyBinCount
                        ? array
                        : new Uint8Array(that.frequencyBinCount);
                }), operators.tap(function (array) { return that.getByteFrequencyData(array); }));
                that.frequencyFloat$ = rxjs.interval(0, rxjs.animationFrameScheduler).pipe(operators.mapTo(new Float32Array(that.frequencyBinCount)), operators.map(function (array) {
                    return array.length === that.frequencyBinCount
                        ? array
                        : new Float32Array(that.frequencyBinCount);
                }), operators.tap(function (array) { return that.getFloatFrequencyData(array); }));
                that.timeByte$ = rxjs.interval(0, rxjs.animationFrameScheduler).pipe(operators.mapTo(new Uint8Array(that.fftSize)), operators.map(function (array) {
                    return array.length === that.fftSize
                        ? array
                        : new Uint8Array(that.frequencyBinCount);
                }), operators.tap(function (array) { return that.getByteTimeDomainData(array); }));
                that.timeFloat$ = rxjs.interval(0, rxjs.animationFrameScheduler).pipe(operators.mapTo(new Float32Array(that.fftSize)), operators.map(function (array) {
                    return array.length === that.fftSize
                        ? array
                        : new Float32Array(that.frequencyBinCount);
                }), operators.tap(function (array) { return that.getFloatTimeDomainData(array); }));
            };
        WebAudioAnalyser.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waAnalyserNode]',
                        exportAs: 'AudioNode',
                        inputs: [
                            'fftSize',
                            'minDecibels',
                            'maxDecibels',
                            'maxDecibels',
                            'smoothingTimeConstant',
                            'channelCount',
                            'channelCountMode',
                            'channelInterpretation',
                        ],
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioAnalyser; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioAnalyser.ctorParameters = function () {
            return [
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.SkipSelf }, { type: i0.Inject, args: [AUDIO_NODE,] }] }
            ];
        };
        WebAudioAnalyser.propDecorators = {
            frequencyByte$: [{ type: i0.Output }],
            frequencyFloat$: [{ type: i0.Output }],
            timeByte$: [{ type: i0.Output }],
            timeFloat$: [{ type: i0.Output }]
        };
        return WebAudioAnalyser;
    }(AnalyserNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioBiquadFilter = /** @class */ (function (_super) {
        __extends(WebAudioBiquadFilter, _super);
        function WebAudioBiquadFilter(context, node) {
            var _this = this;
            /** @type {?} */
            var result = constructorPolyfill(context, 'createBiquadFilter', WebAudioBiquadFilter, node);
            if (result) {
                return result;
            }
            _this = _super.call(this, context) || this;
            WebAudioBiquadFilter.init(_this, node);
            return _this;
        }
        /**
         * @return {?}
         */
        WebAudioBiquadFilter.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
        WebAudioBiquadFilter.init = /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
            function (that, node) {
                connect(node, that);
            };
        WebAudioBiquadFilter.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waBiquadFilterNode]',
                        exportAs: 'AudioNode',
                        inputs: ['type', 'channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioBiquadFilter; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioBiquadFilter.ctorParameters = function () {
            return [
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.SkipSelf }, { type: i0.Inject, args: [AUDIO_NODE,] }] }
            ];
        };
        WebAudioBiquadFilter.propDecorators = {
            gainParam: [{ type: i0.Input, args: ['gain',] }],
            frequencyParam: [{ type: i0.Input, args: ['frequency',] }],
            qParam: [{ type: i0.Input, args: ['Q',] }],
            detuneParam: [{ type: i0.Input, args: ['detune',] }]
        };
        __decorate([
            audioParam('gain'),
            __metadata("design:type", Object)
        ], WebAudioBiquadFilter.prototype, "gainParam", void 0);
        __decorate([
            audioParam('frequency'),
            __metadata("design:type", Object)
        ], WebAudioBiquadFilter.prototype, "frequencyParam", void 0);
        __decorate([
            audioParam('Q'),
            __metadata("design:type", Object)
        ], WebAudioBiquadFilter.prototype, "qParam", void 0);
        __decorate([
            audioParam('detune'),
            __metadata("design:type", Object)
        ], WebAudioBiquadFilter.prototype, "detuneParam", void 0);
        return WebAudioBiquadFilter;
    }(BiquadFilterNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioChannelMerger = /** @class */ (function (_super) {
        __extends(WebAudioChannelMerger, _super);
        function WebAudioChannelMerger(inputs, context) {
            var _this = this;
            /** @type {?} */
            var numberOfInputs = Number.parseInt(inputs || '', 10) || 6;
            try {
                // @ts-ignore
                /** @type {?} */
                var _test = new GainNode(context);
            }
            catch (_) {
                /** @type {?} */
                var result = context.createChannelMerger(numberOfInputs);
                Object.setPrototypeOf(result, WebAudioChannelMerger.prototype);
                return ( /** @type {?} */(result));
            }
            _this = _super.call(this, context, { numberOfInputs: numberOfInputs }) || this;
            return _this;
        }
        Object.defineProperty(WebAudioChannelMerger.prototype, "channels", {
            set: /**
             * @param {?} channels
             * @return {?}
             */ function (channels) {
                var _this = this;
                channels.forEach(function (node, index) {
                    node.connect(_this, 0, index);
                });
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        WebAudioChannelMerger.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        WebAudioChannelMerger.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waChannelMergerNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioChannelMerger; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioChannelMerger.ctorParameters = function () {
            return [
                { type: undefined, decorators: [{ type: i0.Attribute, args: ['numberOfInputs',] }] },
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] }
            ];
        };
        WebAudioChannelMerger.propDecorators = {
            channels: [{ type: i0.ContentChildren, args: [WebAudioChannel, { descendants: false },] }]
        };
        return WebAudioChannelMerger;
    }(ChannelMergerNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioChannelSplitter = /** @class */ (function (_super) {
        __extends(WebAudioChannelSplitter, _super);
        function WebAudioChannelSplitter(outputs, context, node) {
            var _this = this;
            /** @type {?} */
            var numberOfOutputs = Number.parseInt(outputs || '', 10) || 6;
            try {
                // @ts-ignore
                /** @type {?} */
                var _test = new GainNode(context);
            }
            catch (_) {
                /** @type {?} */
                var result = context.createChannelSplitter(numberOfOutputs);
                Object.setPrototypeOf(result, WebAudioChannelSplitter.prototype);
                connect(node, result);
                return ( /** @type {?} */(result));
            }
            _this = _super.call(this, context, { numberOfOutputs: numberOfOutputs }) || this;
            connect(node, _this);
            return _this;
        }
        Object.defineProperty(WebAudioChannelSplitter.prototype, "channels", {
            set: /**
             * @param {?} channels
             * @return {?}
             */ function (channels) {
                var _this = this;
                this.disconnect();
                channels
                    .filter(function (node) { return !!node; })
                    .forEach(function (node, index) {
                    _this.connect(( /** @type {?} */(node)), index);
                });
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        WebAudioChannelSplitter.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        WebAudioChannelSplitter.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waChannelSplitterNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useValue: null,
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioChannelSplitter.ctorParameters = function () {
            return [
                { type: undefined, decorators: [{ type: i0.Attribute, args: ['numberOfOutputs',] }] },
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.SkipSelf }, { type: i0.Inject, args: [AUDIO_NODE,] }] }
            ];
        };
        WebAudioChannelSplitter.propDecorators = {
            channels: [{ type: i0.ContentChildren, args: [( /** @type {?} */(AUDIO_NODE)), { descendants: false },] }]
        };
        return WebAudioChannelSplitter;
    }(ChannelSplitterNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var AudioBufferService = /** @class */ (function () {
        function AudioBufferService(context) {
            this.context = context;
            this.cache = new Map();
        }
        /**
         * @param {?} url
         * @return {?}
         */
        AudioBufferService.prototype.fetch = /**
         * @param {?} url
         * @return {?}
         */
            function (url) {
                var _this = this;
                return new Promise(function (resolve, reject) {
                    if (_this.cache.has(url)) {
                        resolve(_this.cache.get(url));
                        return;
                    }
                    /** @type {?} */
                    var request = new XMLHttpRequest();
                    request.open('GET', url, true);
                    request.responseType = 'arraybuffer';
                    request.onerror = reject;
                    request.onabort = reject;
                    request.onload = function () {
                        _this.context.decodeAudioData(request.response, function (buffer) {
                            _this.cache.set(url, buffer);
                            resolve(buffer);
                        }, reject);
                    };
                    request.send();
                });
            };
        AudioBufferService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root',
                    },] }
        ];
        /** @nocollapse */
        AudioBufferService.ctorParameters = function () {
            return [
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] }
            ];
        };
        /** @nocollapse */ AudioBufferService.ngInjectableDef = i0.defineInjectable({ factory: function AudioBufferService_Factory() { return new AudioBufferService(i0.inject(AUDIO_CONTEXT)); }, token: AudioBufferService, providedIn: "root" });
        return AudioBufferService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioConvolver = /** @class */ (function (_super) {
        __extends(WebAudioConvolver, _super);
        function WebAudioConvolver(audioBufferService, context, node) {
            var _this = this;
            /** @type {?} */
            var result = constructorPolyfill(context, 'createConvolver', WebAudioConvolver, node, audioBufferService);
            if (result) {
                return result;
            }
            _this = _super.call(this, context) || this;
            WebAudioConvolver.init(_this, node, audioBufferService);
            return _this;
        }
        Object.defineProperty(WebAudioConvolver.prototype, "bufferSetter", {
            set: /**
             * @param {?} source
             * @return {?}
             */ function (source) {
                this.buffer$.next(source);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        WebAudioConvolver.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.buffer$.complete();
                this.disconnect();
            };
        /**
         * @param {?} that
         * @param {?} node
         * @param {?} audioBufferService
         * @return {?}
         */
        WebAudioConvolver.init = /**
         * @param {?} that
         * @param {?} node
         * @param {?} audioBufferService
         * @return {?}
         */
            function (that, node, audioBufferService) {
                connect(node, that);
                that.buffer$ = new rxjs.Subject();
                that.buffer$
                    .pipe(operators.switchMap(function (source) {
                    return typeof source === 'string'
                        ? audioBufferService.fetch(source)
                        : rxjs.of(source);
                }))
                    .subscribe(function (buffer) {
                    that.buffer = buffer;
                });
            };
        WebAudioConvolver.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waConvolverNode]',
                        exportAs: 'AudioNode',
                        inputs: ['normalize', 'channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioConvolver; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioConvolver.ctorParameters = function () {
            return [
                { type: AudioBufferService, decorators: [{ type: i0.Inject, args: [AudioBufferService,] }] },
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.SkipSelf }, { type: i0.Inject, args: [AUDIO_NODE,] }] }
            ];
        };
        WebAudioConvolver.propDecorators = {
            bufferSetter: [{ type: i0.Input, args: ['buffer',] }]
        };
        return WebAudioConvolver;
    }(ConvolverNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioDelay = /** @class */ (function (_super) {
        __extends(WebAudioDelay, _super);
        function WebAudioDelay(context, node) {
            var _this = this;
            /** @type {?} */
            var result = constructorPolyfill(context, 'createDelay', WebAudioDelay, node);
            if (result) {
                return result;
            }
            _this = _super.call(this, context) || this;
            WebAudioDelay.init(_this, node);
            return _this;
        }
        /**
         * @return {?}
         */
        WebAudioDelay.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
        WebAudioDelay.init = /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
            function (that, node) {
                connect(node, that);
            };
        WebAudioDelay.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waDelayNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioDelay; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioDelay.ctorParameters = function () {
            return [
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.SkipSelf }, { type: i0.Inject, args: [AUDIO_NODE,] }] }
            ];
        };
        WebAudioDelay.propDecorators = {
            delayTimeParam: [{ type: i0.Input, args: ['delayTime',] }]
        };
        __decorate([
            audioParam('delayTime'),
            __metadata("design:type", Object)
        ], WebAudioDelay.prototype, "delayTimeParam", void 0);
        return WebAudioDelay;
    }(DelayNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioDynamicsCompressor = /** @class */ (function (_super) {
        __extends(WebAudioDynamicsCompressor, _super);
        function WebAudioDynamicsCompressor(context, node) {
            var _this = this;
            /** @type {?} */
            var result = constructorPolyfill(context, 'createDynamicsCompressor', WebAudioDynamicsCompressor, node);
            if (result) {
                return result;
            }
            _this = _super.call(this, context) || this;
            WebAudioDynamicsCompressor.init(_this, node);
            return _this;
        }
        /**
         * @return {?}
         */
        WebAudioDynamicsCompressor.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
        WebAudioDynamicsCompressor.init = /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
            function (that, node) {
                connect(node, that);
            };
        WebAudioDynamicsCompressor.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waDynamicsCompressorNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioDynamicsCompressor; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioDynamicsCompressor.ctorParameters = function () {
            return [
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.SkipSelf }, { type: i0.Inject, args: [AUDIO_NODE,] }] }
            ];
        };
        WebAudioDynamicsCompressor.propDecorators = {
            attackParam: [{ type: i0.Input, args: ['attack',] }],
            kneeParam: [{ type: i0.Input, args: ['knee',] }],
            ratioParam: [{ type: i0.Input, args: ['ratio',] }],
            releaseParam: [{ type: i0.Input, args: ['release',] }],
            thresholdParam: [{ type: i0.Input, args: ['threshold',] }]
        };
        __decorate([
            audioParam('attack'),
            __metadata("design:type", Object)
        ], WebAudioDynamicsCompressor.prototype, "attackParam", void 0);
        __decorate([
            audioParam('knee'),
            __metadata("design:type", Object)
        ], WebAudioDynamicsCompressor.prototype, "kneeParam", void 0);
        __decorate([
            audioParam('ratio'),
            __metadata("design:type", Object)
        ], WebAudioDynamicsCompressor.prototype, "ratioParam", void 0);
        __decorate([
            audioParam('release'),
            __metadata("design:type", Object)
        ], WebAudioDynamicsCompressor.prototype, "releaseParam", void 0);
        __decorate([
            audioParam('threshold'),
            __metadata("design:type", Object)
        ], WebAudioDynamicsCompressor.prototype, "thresholdParam", void 0);
        return WebAudioDynamicsCompressor;
    }(DynamicsCompressorNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioGain = /** @class */ (function (_super) {
        __extends(WebAudioGain, _super);
        function WebAudioGain(context, node) {
            var _this = this;
            /** @type {?} */
            var result = constructorPolyfill(context, 'createGain', WebAudioGain, node);
            if (result) {
                return result;
            }
            _this = _super.call(this, context) || this;
            WebAudioGain.init(_this, node);
            return _this;
        }
        /**
         * @return {?}
         */
        WebAudioGain.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
        WebAudioGain.init = /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
            function (that, node) {
                connect(node, that);
            };
        WebAudioGain.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waGainNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioGain; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioGain.ctorParameters = function () {
            return [
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.SkipSelf }, { type: i0.Inject, args: [AUDIO_NODE,] }] }
            ];
        };
        WebAudioGain.propDecorators = {
            gainParam: [{ type: i0.Input, args: ['gain',] }]
        };
        __decorate([
            audioParam('gain'),
            __metadata("design:type", Object)
        ], WebAudioGain.prototype, "gainParam", void 0);
        return WebAudioGain;
    }(GainNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var FEEDBACK_COEFFICIENTS = new i0.InjectionToken('A sequence of feedback coefficients for IIRFilterNode');

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var FEEDFORWARD_COEFFICIENTS = new i0.InjectionToken('A sequence of feedforward coefficients for IIRFilterNode');

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioIIRFilter = /** @class */ (function (_super) {
        __extends(WebAudioIIRFilter, _super);
        function WebAudioIIRFilter(feedback, feedforward, context, node) {
            var _this = this;
            try {
                // @ts-ignore
                /** @type {?} */
                var _test = new IIRFilterNode(context, { feedback: feedback, feedforward: feedforward });
            }
            catch (_) {
                /** @type {?} */
                var result = ( /** @type {?} */(context.createIIRFilter(feedback, feedforward)));
                Object.setPrototypeOf(result, WebAudioIIRFilter.prototype);
                connect(node, result);
                return result;
            }
            _this = _super.call(this, context, { feedback: feedback, feedforward: feedforward }) || this;
            connect(node, _this);
            return _this;
        }
        /**
         * @return {?}
         */
        WebAudioIIRFilter.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        WebAudioIIRFilter.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waIIRFilterNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioIIRFilter; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioIIRFilter.ctorParameters = function () {
            return [
                { type: Array, decorators: [{ type: i0.Inject, args: [FEEDBACK_COEFFICIENTS,] }] },
                { type: Array, decorators: [{ type: i0.Inject, args: [FEEDFORWARD_COEFFICIENTS,] }] },
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.SkipSelf }, { type: i0.Inject, args: [AUDIO_NODE,] }] }
            ];
        };
        return WebAudioIIRFilter;
    }(IIRFilterNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioPanner = /** @class */ (function (_super) {
        __extends(WebAudioPanner, _super);
        function WebAudioPanner(context, node) {
            var _this = this;
            /** @type {?} */
            var result = constructorPolyfill(context, 'createPanner', WebAudioPanner, node);
            if (result) {
                return result;
            }
            _this = _super.call(this, context) || this;
            WebAudioPanner.init(_this, node);
            return _this;
        }
        /**
         * @return {?}
         */
        WebAudioPanner.prototype.ngOnChanges = /**
         * @return {?}
         */
            function () {
                if (this.positionX instanceof AudioParam) {
                    return;
                }
                // Fallback for older browsers
                this.setOrientation(fallbackAudioParam(this.orientationXParam), fallbackAudioParam(this.orientationYParam), fallbackAudioParam(this.orientationZParam));
                this.setPosition(fallbackAudioParam(this.positionXParam), fallbackAudioParam(this.positionYParam), fallbackAudioParam(this.positionZParam));
            };
        /**
         * @return {?}
         */
        WebAudioPanner.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
        WebAudioPanner.init = /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
            function (that, node) {
                connect(node, that);
            };
        WebAudioPanner.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waPannerNode]',
                        exportAs: 'AudioNode',
                        inputs: [
                            'coneInnerAngle',
                            'coneOuterAngle',
                            'coneOuterGain',
                            'distanceModel',
                            'maxDistance',
                            'panningModel',
                            'refDistance',
                            'rolloffFactor',
                            'channelCount',
                            'channelCountMode',
                            'channelInterpretation',
                        ],
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioPanner; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioPanner.ctorParameters = function () {
            return [
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.SkipSelf }, { type: i0.Inject, args: [AUDIO_NODE,] }] }
            ];
        };
        WebAudioPanner.propDecorators = {
            orientationXParam: [{ type: i0.Input }],
            orientationYParam: [{ type: i0.Input }],
            orientationZParam: [{ type: i0.Input }],
            positionXParam: [{ type: i0.Input }],
            positionYParam: [{ type: i0.Input }],
            positionZParam: [{ type: i0.Input }]
        };
        __decorate([
            audioParam('orientationX'),
            __metadata("design:type", Object)
        ], WebAudioPanner.prototype, "orientationXParam", void 0);
        __decorate([
            audioParam('orientationY'),
            __metadata("design:type", Object)
        ], WebAudioPanner.prototype, "orientationYParam", void 0);
        __decorate([
            audioParam('orientationZ'),
            __metadata("design:type", Object)
        ], WebAudioPanner.prototype, "orientationZParam", void 0);
        __decorate([
            audioParam('positionX'),
            __metadata("design:type", Object)
        ], WebAudioPanner.prototype, "positionXParam", void 0);
        __decorate([
            audioParam('positionY'),
            __metadata("design:type", Object)
        ], WebAudioPanner.prototype, "positionYParam", void 0);
        __decorate([
            audioParam('positionZ'),
            __metadata("design:type", Object)
        ], WebAudioPanner.prototype, "positionZParam", void 0);
        return WebAudioPanner;
    }(PannerNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioScriptProcessor = /** @class */ (function (_super) {
        __extends(WebAudioScriptProcessor, _super);
        function WebAudioScriptProcessor(bufferSize, numberOfInputChannels, numberOfOutputChannels, context, node) {
            var _this = this;
            try {
                /** @type {?} */
                var result = ( /** @type {?} */(context.createScriptProcessor(Number.parseInt(bufferSize || '', 10) || 0, Number.parseInt(numberOfInputChannels || '', 10) || 2, Number.parseInt(numberOfOutputChannels || '', 10) || 2)));
                Object.setPrototypeOf(result, WebAudioScriptProcessor.prototype);
                connect(node, result);
                /** @type {?} */
                var audioprocess_1 = new i0.EventEmitter();
                result.audioprocess = audioprocess_1;
                result.onaudioprocess = function (e) { return audioprocess_1.emit(e); };
                return result;
            }
            catch (_) { }
            _this = _super.call(this) || this;
            return _this;
        }
        /**
         * @return {?}
         */
        WebAudioScriptProcessor.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        WebAudioScriptProcessor.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waScriptProcessorNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioScriptProcessor; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioScriptProcessor.ctorParameters = function () {
            return [
                { type: undefined, decorators: [{ type: i0.Attribute, args: ['bufferSize',] }] },
                { type: undefined, decorators: [{ type: i0.Attribute, args: ['numberOfInputChannels',] }] },
                { type: undefined, decorators: [{ type: i0.Attribute, args: ['numberOfOutputChannels',] }] },
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.SkipSelf }, { type: i0.Inject, args: [AUDIO_NODE,] }] }
            ];
        };
        WebAudioScriptProcessor.propDecorators = {
            audioprocess: [{ type: i0.Output }]
        };
        return WebAudioScriptProcessor;
    }(ScriptProcessorNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioStereoPanner = /** @class */ (function (_super) {
        __extends(WebAudioStereoPanner, _super);
        function WebAudioStereoPanner(context, node) {
            var _this = this;
            try {
                // @ts-ignore
                /** @type {?} */
                var _test = new StereoPannerNode(context);
            }
            catch (_) {
                /** @type {?} */
                var result = ( /** @type {?} */((( /** @type {?} */(context.createPanner())))));
                Object.setPrototypeOf(result, WebAudioStereoPanner.prototype);
                WebAudioStereoPanner.init(result, node);
                return result;
            }
            _this = _super.call(this, context) || this;
            WebAudioStereoPanner.init(_this, node);
            return _this;
        }
        Object.defineProperty(WebAudioStereoPanner.prototype, "panParam", {
            set: /**
             * @param {?} pan
             * @return {?}
             */ function (pan) {
                if ('setPosition' in this) {
                    /** fallback for browsers not supporting {@link StereoPannerNode} */
                    // @ts-ignore
                    this.fallbackToPannerNode(fallbackAudioParam(pan));
                }
                else {
                    processAudioParam(this.pan, pan, this.context.currentTime);
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        WebAudioStereoPanner.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        // @ts-ignore
        // @ts-ignore
        /**
         * @private
         * @param {?} pan
         * @return {?}
         */
        WebAudioStereoPanner.prototype.fallbackToPannerNode =
            // @ts-ignore
            /**
             * @private
             * @param {?} pan
             * @return {?}
             */
            function (pan) {
                /** @type {?} */
                var xDeg = pan * 100;
                /** @type {?} */
                var zDeg = xDeg > 0 ? 270 - xDeg : xDeg + 90;
                /** @type {?} */
                var x = Math.sin(xDeg * (Math.PI / 180));
                /** @type {?} */
                var z = Math.sin(zDeg * (Math.PI / 180));
                // @ts-ignore
                this.setPosition(x, 0, z);
            };
        /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
        WebAudioStereoPanner.init = /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
            function (that, node) {
                connect(node, that);
            };
        WebAudioStereoPanner.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waStereoPannerNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioStereoPanner; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioStereoPanner.ctorParameters = function () {
            return [
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.SkipSelf }, { type: i0.Inject, args: [AUDIO_NODE,] }] }
            ];
        };
        WebAudioStereoPanner.propDecorators = {
            panParam: [{ type: i0.Input, args: ['pan',] }]
        };
        return WebAudioStereoPanner;
    }(StereoPannerNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioWaveShaper = /** @class */ (function (_super) {
        __extends(WebAudioWaveShaper, _super);
        function WebAudioWaveShaper(context, node) {
            var _this = this;
            /** @type {?} */
            var result = constructorPolyfill(context, 'createWaveShaper', WebAudioWaveShaper, node);
            if (result) {
                return result;
            }
            _this = _super.call(this, context) || this;
            WebAudioWaveShaper.init(_this, node);
            return _this;
        }
        /**
         * @return {?}
         */
        WebAudioWaveShaper.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
        WebAudioWaveShaper.init = /**
         * @param {?} that
         * @param {?} node
         * @return {?}
         */
            function (that, node) {
                connect(node, that);
            };
        WebAudioWaveShaper.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waWaveShaperNode]',
                        exportAs: 'AudioNode',
                        inputs: [
                            'oversample',
                            'curve',
                            'channelCount',
                            'channelCountMode',
                            'channelInterpretation',
                        ],
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioWaveShaper; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioWaveShaper.ctorParameters = function () {
            return [
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.SkipSelf }, { type: i0.Inject, args: [AUDIO_NODE,] }] }
            ];
        };
        return WebAudioWaveShaper;
    }(WaveShaperNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioWorklet = /** @class */ (function (_super) {
        __extends(WebAudioWorklet, _super);
        function WebAudioWorklet(context, node, name) {
            var _this = _super.call(this, context, name) || this;
            _this.processorerror = new i0.EventEmitter();
            _this.onprocessorerror = function () { return _this.processorerror.emit(); };
            connect(node, _this);
            return _this;
        }
        /**
         * @return {?}
         */
        WebAudioWorklet.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        WebAudioWorklet.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waAudioWorkletNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioWorklet; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioWorklet.ctorParameters = function () {
            return [
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.SkipSelf }, { type: i0.Inject, args: [AUDIO_NODE,] }] },
                { type: String, decorators: [{ type: i0.Attribute, args: ['name',] }] }
            ];
        };
        WebAudioWorklet.propDecorators = {
            processorerror: [{ type: i0.Output }]
        };
        return WebAudioWorklet;
    }(AudioWorkletNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var WebAudioParamPipe = /** @class */ (function () {
        function WebAudioParamPipe() {
        }
        /**
         * Creates {@link AudioParamAutomation} to use with {@link AudioParam} inputs
         *
         * @param value target value
         * @param duration duration of the automation
         * @param mode either instant for given duration or linear/exponential ramp
         */
        /**
         * Creates {\@link AudioParamAutomation} to use with {\@link AudioParam} inputs
         *
         * @param {?} value target value
         * @param {?=} duration duration of the automation
         * @param {?=} mode either instant for given duration or linear/exponential ramp
         * @return {?}
         */
        WebAudioParamPipe.prototype.transform = /**
         * Creates {\@link AudioParamAutomation} to use with {\@link AudioParam} inputs
         *
         * @param {?} value target value
         * @param {?=} duration duration of the automation
         * @param {?=} mode either instant for given duration or linear/exponential ramp
         * @return {?}
         */
            function (value, duration, mode) {
                if (duration === void 0) {
                    duration = 0;
                }
                if (mode === void 0) {
                    mode = 'exponential';
                }
                return value instanceof Array
                    ? {
                        value: value,
                        duration: duration,
                    }
                    : {
                        value: value,
                        duration: duration,
                        mode: mode,
                    };
            };
        WebAudioParamPipe.decorators = [
            { type: i0.Pipe, args: [{
                        name: 'waAudioParam',
                    },] }
        ];
        return WebAudioParamPipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioPeriodicWavePipe = /** @class */ (function () {
        function WebAudioPeriodicWavePipe(context) {
            this.context = context;
        }
        /**
         * Creates {@link PeriodicWave} to use with {@link OscillatorNode}
         *
         * @param real cosine terms (traditionally the A terms)
         * @param imag sine terms (traditionally the B terms)
         * @param disableNormalization see {@lin PeriodicWaveConstraints}
         */
        /**
         * Creates {\@link PeriodicWave} to use with {\@link OscillatorNode}
         *
         * @param {?} real cosine terms (traditionally the A terms)
         * @param {?=} imag sine terms (traditionally the B terms)
         * @param {?=} disableNormalization see {\@lin PeriodicWaveConstraints}
         * @return {?}
         */
        WebAudioPeriodicWavePipe.prototype.transform = /**
         * Creates {\@link PeriodicWave} to use with {\@link OscillatorNode}
         *
         * @param {?} real cosine terms (traditionally the A terms)
         * @param {?=} imag sine terms (traditionally the B terms)
         * @param {?=} disableNormalization see {\@lin PeriodicWaveConstraints}
         * @return {?}
         */
            function (real, imag, disableNormalization) {
                return this.context.createPeriodicWave(new Float32Array(real), imag ? new Float32Array(imag) : new Float32Array(real.length), {
                    disableNormalization: !!disableNormalization,
                });
            };
        WebAudioPeriodicWavePipe.decorators = [
            { type: i0.Pipe, args: [{
                        name: 'waPeriodicWave',
                    },] }
        ];
        /** @nocollapse */
        WebAudioPeriodicWavePipe.ctorParameters = function () {
            return [
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] }
            ];
        };
        return WebAudioPeriodicWavePipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioBufferSource = /** @class */ (function (_super) {
        __extends(WebAudioBufferSource, _super);
        function WebAudioBufferSource(audioBufferService, context, autoplay) {
            var _this = this;
            /** @type {?} */
            var result = constructorPolyfill(context, 'createBufferSource', WebAudioBufferSource, null, autoplay, audioBufferService);
            if (result) {
                return result;
            }
            _this = _super.call(this, context) || this;
            WebAudioBufferSource.init(_this, null, autoplay, audioBufferService);
            return _this;
        }
        Object.defineProperty(WebAudioBufferSource.prototype, "bufferSetter", {
            set: /**
             * @param {?} source
             * @return {?}
             */ function (source) {
                this.buffer$.next(source);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        WebAudioBufferSource.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.buffer$.complete();
                try {
                    this.stop();
                }
                catch (_) { }
                this.disconnect();
            };
        /**
         * @param {?} that
         * @param {?} _node
         * @param {?} autoplay
         * @param {?} audioBufferService
         * @return {?}
         */
        WebAudioBufferSource.init = /**
         * @param {?} that
         * @param {?} _node
         * @param {?} autoplay
         * @param {?} audioBufferService
         * @return {?}
         */
            function (that, _node, autoplay, audioBufferService) {
                if (autoplay !== null) {
                    that.start();
                }
                /** @type {?} */
                var ended = new i0.EventEmitter();
                that.ended = ended;
                that.onended = function () { return ended.emit(); };
                that.buffer$ = new rxjs.Subject();
                that.buffer$
                    .pipe(operators.switchMap(function (source) {
                    return typeof source === 'string'
                        ? audioBufferService.fetch(source)
                        : rxjs.of(source);
                }))
                    .subscribe(function (buffer) {
                    that.buffer = buffer;
                });
            };
        WebAudioBufferSource.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waAudioBufferSourceNode]',
                        exportAs: 'AudioNode',
                        inputs: [
                            'loop',
                            'loopStart',
                            'loopEnd',
                            'channelCount',
                            'channelCountMode',
                            'channelInterpretation',
                        ],
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioBufferSource; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioBufferSource.ctorParameters = function () {
            return [
                { type: AudioBufferService, decorators: [{ type: i0.Inject, args: [AudioBufferService,] }] },
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.Attribute, args: ['autoplay',] }] }
            ];
        };
        WebAudioBufferSource.propDecorators = {
            bufferSetter: [{ type: i0.Input, args: ['buffer',] }],
            detuneParam: [{ type: i0.Input, args: ['detune',] }],
            playbackRateParam: [{ type: i0.Input, args: ['playbackRate',] }],
            ended: [{ type: i0.Output }]
        };
        __decorate([
            audioParam('detune'),
            __metadata("design:type", Object)
        ], WebAudioBufferSource.prototype, "detuneParam", void 0);
        __decorate([
            audioParam('playbackRate'),
            __metadata("design:type", Object)
        ], WebAudioBufferSource.prototype, "playbackRateParam", void 0);
        return WebAudioBufferSource;
    }(AudioBufferSourceNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioConstantSource = /** @class */ (function (_super) {
        __extends(WebAudioConstantSource, _super);
        function WebAudioConstantSource(context, autoplay) {
            var _this = _super.call(this, context) || this;
            _this.ended = new i0.EventEmitter();
            _this.onended = function () { return _this.ended.emit(); };
            if (autoplay !== null) {
                _this.start();
            }
            return _this;
        }
        /**
         * @return {?}
         */
        WebAudioConstantSource.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                try {
                    this.stop();
                }
                catch (_) { }
                this.disconnect();
            };
        WebAudioConstantSource.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waConstantSourceNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioConstantSource; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioConstantSource.ctorParameters = function () {
            return [
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.Attribute, args: ['autoplay',] }] }
            ];
        };
        WebAudioConstantSource.propDecorators = {
            offsetParam: [{ type: i0.Input, args: ['offset',] }],
            ended: [{ type: i0.Output }]
        };
        __decorate([
            audioParam('offset'),
            __metadata("design:type", Object)
        ], WebAudioConstantSource.prototype, "offsetParam", void 0);
        return WebAudioConstantSource;
    }(ConstantSourceNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioMediaSource = /** @class */ (function (_super) {
        __extends(WebAudioMediaSource, _super);
        function WebAudioMediaSource(context, _a) {
            var nativeElement = _a.nativeElement;
            var _this = this;
            try {
                // @ts-ignore
                /** @type {?} */
                var _test = new GainNode(context);
            }
            catch (_) {
                /** @type {?} */
                var result = context.createMediaElementSource(nativeElement);
                Object.setPrototypeOf(result, WebAudioMediaSource.prototype);
                return ( /** @type {?} */(result));
            }
            _this = _super.call(this, context, { mediaElement: nativeElement }) || this;
            return _this;
        }
        /**
         * @return {?}
         */
        WebAudioMediaSource.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        WebAudioMediaSource.decorators = [
            { type: i0.Directive, args: [{
                        selector: 'audio[waMediaElementAudioSourceNode], video[waMediaElementAudioSourceNode]',
                        exportAs: 'AudioNode',
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioMediaSource; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioMediaSource.ctorParameters = function () {
            return [
                { type: AudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: i0.ElementRef, decorators: [{ type: i0.Inject, args: [i0.ElementRef,] }] }
            ];
        };
        return WebAudioMediaSource;
    }(MediaElementAudioSourceNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var MEDIA_STREAM = new i0.InjectionToken('MediaStream for MediaStreamAudioSourceNode');

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioMediaStreamSource = /** @class */ (function (_super) {
        __extends(WebAudioMediaStreamSource, _super);
        function WebAudioMediaStreamSource(mediaStream, context) {
            var _this = this;
            try {
                // @ts-ignore
                /** @type {?} */
                var _test = new GainNode(context);
            }
            catch (_) {
                /** @type {?} */
                var result = context.createMediaStreamSource(mediaStream);
                Object.setPrototypeOf(result, WebAudioMediaStreamSource.prototype);
                return ( /** @type {?} */(result));
            }
            _this = _super.call(this, context, { mediaStream: mediaStream }) || this;
            return _this;
        }
        /**
         * @return {?}
         */
        WebAudioMediaStreamSource.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        WebAudioMediaStreamSource.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waMediaStreamAudioSourceNode]',
                        exportAs: 'AudioNode',
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioMediaStreamSource; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioMediaStreamSource.ctorParameters = function () {
            return [
                { type: MediaStream, decorators: [{ type: i0.Inject, args: [MEDIA_STREAM,] }] },
                { type: AudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] }
            ];
        };
        return WebAudioMediaStreamSource;
    }(MediaStreamAudioSourceNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var MEDIA_STREAM_TRACK = new i0.InjectionToken('MediaStreamTrack for MediaStreamTrackAudioSourceNode');

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioMediaStreamTrackSource = /** @class */ (function (_super) {
        __extends(WebAudioMediaStreamTrackSource, _super);
        function WebAudioMediaStreamTrackSource(mediaStreamTrack, context) {
            return _super.call(this, context, { mediaStreamTrack: mediaStreamTrack }) || this;
        }
        /**
         * @return {?}
         */
        WebAudioMediaStreamTrackSource.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.disconnect();
            };
        WebAudioMediaStreamTrackSource.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waMediaStreamTrackAudioSourceNode]',
                        exportAs: 'AudioNode',
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioMediaStreamTrackSource; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioMediaStreamTrackSource.ctorParameters = function () {
            return [
                { type: MediaStreamTrack, decorators: [{ type: i0.Inject, args: [MEDIA_STREAM_TRACK,] }] },
                { type: AudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] }
            ];
        };
        return WebAudioMediaStreamTrackSource;
    }(MediaStreamTrackAudioSourceNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var WebAudioOscillator = /** @class */ (function (_super) {
        __extends(WebAudioOscillator, _super);
        function WebAudioOscillator(context, autoplay) {
            var _this = this;
            /** @type {?} */
            var result = constructorPolyfill(context, 'createOscillator', WebAudioOscillator, null, autoplay);
            if (result) {
                return result;
            }
            _this = _super.call(this, context) || this;
            WebAudioOscillator.init(_this, null, autoplay);
            return _this;
        }
        Object.defineProperty(WebAudioOscillator.prototype, "periodicWave", {
            set: /**
             * @param {?} periodicWave
             * @return {?}
             */ function (periodicWave) {
                this.setPeriodicWave(periodicWave);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        WebAudioOscillator.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                try {
                    this.stop();
                }
                catch (_) { }
                this.disconnect();
            };
        /**
         * @param {?} that
         * @param {?} node
         * @param {?} autoplay
         * @return {?}
         */
        WebAudioOscillator.init = /**
         * @param {?} that
         * @param {?} node
         * @param {?} autoplay
         * @return {?}
         */
            function (that, node, autoplay) {
                connect(node, that);
                if (autoplay !== null) {
                    that.start();
                }
                /** @type {?} */
                var ended = new i0.EventEmitter();
                that.ended = ended;
                that.onended = function () { return ended.emit(); };
            };
        WebAudioOscillator.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[waOscillatorNode]',
                        exportAs: 'AudioNode',
                        inputs: ['type', 'channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useExisting: i0.forwardRef(function () { return WebAudioOscillator; }),
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        WebAudioOscillator.ctorParameters = function () {
            return [
                { type: BaseAudioContext, decorators: [{ type: i0.Inject, args: [AUDIO_CONTEXT,] }] },
                { type: undefined, decorators: [{ type: i0.Attribute, args: ['autoplay',] }] }
            ];
        };
        WebAudioOscillator.propDecorators = {
            periodicWave: [{ type: i0.Input }],
            detuneParam: [{ type: i0.Input, args: ['detune',] }],
            frequencyParam: [{ type: i0.Input, args: ['frequency',] }],
            ended: [{ type: i0.Output }]
        };
        __decorate([
            audioParam('detune'),
            __metadata("design:type", Object)
        ], WebAudioOscillator.prototype, "detuneParam", void 0);
        __decorate([
            audioParam('frequency'),
            __metadata("design:type", Object)
        ], WebAudioOscillator.prototype, "frequencyParam", void 0);
        return WebAudioOscillator;
    }(OscillatorNode));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var AUDIO_WORKLET_PROCESSORS = new i0.InjectionToken('Web Audio API worklet processors paths', {
        providedIn: 'root',
        factory: function () { return []; },
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var AUDIO_WORKLET_PROCESSORS_INIT = new i0.InjectionToken('Web Audio API worklet processors resolution promise', {
        providedIn: 'root',
        factory: function () {
            /** @type {?} */
            var context = i0.inject(AUDIO_CONTEXT);
            /** @type {?} */
            var processors = i0.inject(AUDIO_WORKLET_PROCESSORS);
            if (!context.audioWorklet) {
                return Promise.reject('AudioWorklet is not supported');
            }
            return Promise.all(processors.map(function (processor) { return context.audioWorklet.addModule(processor); }));
        },
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var WebAudioModule = /** @class */ (function () {
        function WebAudioModule() {
        }
        WebAudioModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [
                            WebAudioContext,
                            WebAudioChannel,
                            WebAudioDestination,
                            WebAudioListener,
                            WebAudioOfflineContext,
                            WebAudioOutput,
                            WebAudioMediaStreamDestination,
                            WebAudioBufferSource,
                            WebAudioConstantSource,
                            WebAudioMediaSource,
                            WebAudioMediaStreamSource,
                            WebAudioMediaStreamTrackSource,
                            WebAudioOscillator,
                            WebAudioAnalyser,
                            WebAudioBiquadFilter,
                            WebAudioChannelSplitter,
                            WebAudioChannelMerger,
                            WebAudioConvolver,
                            WebAudioDelay,
                            WebAudioDynamicsCompressor,
                            WebAudioGain,
                            WebAudioIIRFilter,
                            WebAudioPanner,
                            WebAudioScriptProcessor,
                            WebAudioStereoPanner,
                            WebAudioWaveShaper,
                            WebAudioWorklet,
                            WebAudioParamPipe,
                            WebAudioPeriodicWavePipe,
                        ],
                        exports: [
                            WebAudioContext,
                            WebAudioChannel,
                            WebAudioDestination,
                            WebAudioListener,
                            WebAudioOfflineContext,
                            WebAudioOutput,
                            WebAudioMediaStreamDestination,
                            WebAudioBufferSource,
                            WebAudioConstantSource,
                            WebAudioMediaSource,
                            WebAudioMediaStreamSource,
                            WebAudioMediaStreamTrackSource,
                            WebAudioOscillator,
                            WebAudioAnalyser,
                            WebAudioBiquadFilter,
                            WebAudioChannelSplitter,
                            WebAudioChannelMerger,
                            WebAudioConvolver,
                            WebAudioDelay,
                            WebAudioDynamicsCompressor,
                            WebAudioGain,
                            WebAudioIIRFilter,
                            WebAudioPanner,
                            WebAudioScriptProcessor,
                            WebAudioStereoPanner,
                            WebAudioWaveShaper,
                            WebAudioWorklet,
                            WebAudioParamPipe,
                            WebAudioPeriodicWavePipe,
                        ],
                    },] }
        ];
        return WebAudioModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.audioParam = audioParam;
    exports.WebAudioContext = WebAudioContext;
    exports.WebAudioChannel = WebAudioChannel;
    exports.WebAudioDestination = WebAudioDestination;
    exports.WebAudioListener = WebAudioListener;
    exports.WebAudioOfflineContext = WebAudioOfflineContext;
    exports.WebAudioOutput = WebAudioOutput;
    exports.WebAudioMediaStreamDestination = WebAudioMediaStreamDestination;
    exports.WebAudioAnalyser = WebAudioAnalyser;
    exports.WebAudioBiquadFilter = WebAudioBiquadFilter;
    exports.WebAudioChannelMerger = WebAudioChannelMerger;
    exports.WebAudioChannelSplitter = WebAudioChannelSplitter;
    exports.WebAudioConvolver = WebAudioConvolver;
    exports.WebAudioDelay = WebAudioDelay;
    exports.WebAudioDynamicsCompressor = WebAudioDynamicsCompressor;
    exports.WebAudioGain = WebAudioGain;
    exports.WebAudioIIRFilter = WebAudioIIRFilter;
    exports.WebAudioPanner = WebAudioPanner;
    exports.WebAudioScriptProcessor = WebAudioScriptProcessor;
    exports.WebAudioStereoPanner = WebAudioStereoPanner;
    exports.WebAudioWaveShaper = WebAudioWaveShaper;
    exports.WebAudioWorklet = WebAudioWorklet;
    exports.WebAudioParamPipe = WebAudioParamPipe;
    exports.WebAudioPeriodicWavePipe = WebAudioPeriodicWavePipe;
    exports.AudioBufferService = AudioBufferService;
    exports.WebAudioBufferSource = WebAudioBufferSource;
    exports.WebAudioConstantSource = WebAudioConstantSource;
    exports.WebAudioMediaSource = WebAudioMediaSource;
    exports.WebAudioMediaStreamSource = WebAudioMediaStreamSource;
    exports.WebAudioMediaStreamTrackSource = WebAudioMediaStreamTrackSource;
    exports.WebAudioOscillator = WebAudioOscillator;
    exports.AUDIO_CONTEXT = AUDIO_CONTEXT;
    exports.AUDIO_NODE = AUDIO_NODE;
    exports.AUDIO_WORKLET_PROCESSORS = AUDIO_WORKLET_PROCESSORS;
    exports.AUDIO_WORKLET_PROCESSORS_INIT = AUDIO_WORKLET_PROCESSORS_INIT;
    exports.FEEDBACK_COEFFICIENTS = FEEDBACK_COEFFICIENTS;
    exports.FEEDFORWARD_COEFFICIENTS = FEEDFORWARD_COEFFICIENTS;
    exports.MEDIA_STREAM = MEDIA_STREAM;
    exports.MEDIA_STREAM_TRACK = MEDIA_STREAM_TRACK;
    exports.WebAudioModule = WebAudioModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ng-web-apis-audio.umd.js.map