import { PipeTransform } from '@angular/core';
import { AudioParamAutomation } from '../types/audio-param-automation';
import { AudioParamAutomationMode } from '../types/audio-param-automation-mode';
import { AudioParamCurve } from '../types/audio-param-curve';
export declare class WebAudioParamPipe implements PipeTransform {
    /**
     * Creates {@link AudioParamAutomation} to use with {@link AudioParam} inputs
     *
     * @param value target value
     * @param duration duration of the automation
     * @param mode either instant for given duration or linear/exponential ramp
     */
    transform(value: number | number[], duration?: number, mode?: AudioParamAutomationMode): AudioParamAutomation | AudioParamCurve;
}
